#include <string.h>
#include <stddef.h>
#include <stdbool.h>

struct Kontakt
{
  char nachname[32];
  char vorname[32];
  char telefonnummer[32];
};
typedef struct Kontakt Kontakt;

// Soll sortiert sein!
Kontakt telefonbuch[] =
{
  {"Mayer","Berta","1234"},
  {"Meier","Carla","2345"},
  {"Meier","Egon","3452"},
  {"Mueller","Hans","643432"},
  {"Zacharias","Anton","3452"}
};
int zahlKontakte = 5;

// TODO: Name mehrfach?!?

char* suche(char nachname[], char vorname[])
{
  for(int i = 0; i < zahlKontakte; i++)
  {
    if(strcmp(telefonbuch[i].nachname, nachname) == 0
       && strcmp(telefonbuch[i].vorname, vorname) == 0)
    {
      return telefonbuch[i].telefonnummer;
    }
  }
  return NULL;
}

char* sucheBinaer(char nachname[], char vorname[])
{
  int anfang = 0;
  int ende = zahlKontakte - 1;
  while(true) // Vorsicht: versteckte returns!
  {
    int mitte = (anfang + ende)/2; // TODO: berlauf?
    if(strcmp(telefonbuch[mitte].nachname, nachname) < 0
       || strcmp(telefonbuch[mitte].nachname, nachname) == 0
       && strcmp(telefonbuch[mitte].vorname, vorname) < 0)
    {
      anfang = mitte + 1;
    }
    else if(strcmp(telefonbuch[mitte].nachname, nachname) > 0
            || strcmp(telefonbuch[mitte].nachname, nachname) == 0
            && strcmp(telefonbuch[mitte].vorname, vorname) > 0)
    {
      ende = mitte - 1;
    }
    else // Treffer!
    {
      return telefonbuch[mitte].telefonnummer;
    }
    
    if(anfang > ende)
    {
      return NULL;
    }
  }
}

int main( void )
{

  char* resultat = sucheBinaer("Mueller","Hans");
  resultat = sucheBinaer("Mueller","Friedrich");

  return 0;
}
